DROP TABLE IF EXISTS `ey_addonarticle`;
DROP TABLE IF EXISTS `ey_addondownload`;
DROP TABLE IF EXISTS `ey_addonimages`;
DROP TABLE IF EXISTS `ey_addonproduct`;
DROP TABLE IF EXISTS `ey_plugin`;
DROP TABLE IF EXISTS `ey_sms_log`;
DROP TABLE IF EXISTS `ey_sms_template`;
DROP TABLE IF EXISTS `ey_email_template`;
DROP TABLE IF EXISTS `ey_auth_access`;
DROP TABLE IF EXISTS `ey_auth_modular`;
DROP TABLE IF EXISTS `ey_auth_role_admin`;
DROP TABLE IF EXISTS `ey_auth_rule`;
DROP TABLE IF EXISTS `ey_links_copy`;
DROP TABLE IF EXISTS `ey_auth_role`;
CREATE TABLE `ey_auth_role` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT '' COMMENT '角色名',
  `pid` int(10) DEFAULT '0' COMMENT '父角色ID',
  `remark` text COMMENT '备注信息',
  `grade` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '级别',
  `language` text COMMENT '多语言权限',
  `online_update` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '在线升级',
  `only_oneself` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '只看自己发布',
  `cud` varchar(255) DEFAULT '' COMMENT '增改删',
  `permission` text COMMENT '已允许的权限',
  `built_in` tinyint(1) DEFAULT '0' COMMENT '内置用户组，1表示内置',
  `sort_order` int(10) DEFAULT '0' COMMENT '排序号',
  `status` tinyint(1) DEFAULT '1' COMMENT '状态(1=正常，0=屏蔽)',
  `admin_id` int(10) DEFAULT '0' COMMENT '操作管理员ID',
  `add_time` int(11) DEFAULT '0' COMMENT '新增时间',
  `update_time` int(11) DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='管理员角色表';
ALTER TABLE `ey_admin` ADD COLUMN `role_id`  int(10) NOT NULL DEFAULT '-1' COMMENT '角色组ID（-1表示超级管理员）' AFTER `session_id`;
ALTER TABLE `ey_admin` ADD COLUMN `parent_id`  int(10) NULL DEFAULT 0 COMMENT '父管理员ID' AFTER `session_id`;
ALTER TABLE `ey_archives` ADD COLUMN `admin_id`  int(10) NULL DEFAULT 0 COMMENT '管理员ID' AFTER `sort_order`;
ALTER TABLE `ey_arctype` ADD COLUMN `admin_id`  int(10) NULL DEFAULT 0 COMMENT '管理员ID' AFTER `is_part`;
ALTER TABLE `ey_weapp` ADD COLUMN `data`  text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '额外序列化存储数据，简单插件可以不创建表，存储这里即可' AFTER `config`;
ALTER TABLE `ey_weapp` ADD COLUMN `tag_weapp`  tinyint(1) NULL DEFAULT 1 COMMENT '1=自动绑定，2=手工调用。关联模板标签weapp，自动调用内置的show钩子方法' AFTER `status`;
ALTER TABLE `ey_weapp` DROP COLUMN `author`;
ALTER TABLE `ey_weapp` DROP COLUMN `description`;
ALTER TABLE `ey_weapp` DROP COLUMN `min_version`;
ALTER TABLE `ey_weapp` DROP COLUMN `scene`;
UPDATE `ey_admin` SET `role_id` = '-1' WHERE `admin_id` > 0;
INSERT INTO `ey_auth_role` VALUES ('1', '优化推广员', '0', '', '0', 'a:1:{i:0;s:2:\"cn\";}', '0', '1', 'a:3:{i:0;s:3:\"add\";i:1;s:4:\"edit\";i:2;s:3:\"del\";}', 'a:2:{s:5:\"rules\";a:8:{i:0;s:1:\"1\";i:1;s:1:\"3\";i:2;s:1:\"4\";i:3;s:1:\"8\";i:4;s:1:\"9\";i:5;s:2:\"10\";i:6;s:2:\"14\";i:7;i:2;}s:7:\"arctype\";a:40:{i:0;s:1:\"1\";i:1;s:1:\"2\";i:2;s:1:\"3\";i:3;s:1:\"4\";i:4;s:1:\"5\";i:5;s:1:\"6\";i:6;s:2:\"33\";i:7;s:2:\"34\";i:8;s:2:\"35\";i:9;s:2:\"36\";i:10;s:2:\"37\";i:11;s:2:\"38\";i:12;s:2:\"39\";i:13;s:2:\"40\";i:14;s:2:\"41\";i:15;s:2:\"42\";i:16;s:2:\"43\";i:17;s:2:\"44\";i:18;s:2:\"45\";i:19;s:2:\"46\";i:20;s:2:\"47\";i:21;s:2:\"48\";i:22;s:1:\"8\";i:23;s:2:\"32\";i:24;s:1:\"9\";i:25;s:2:\"30\";i:26;s:2:\"31\";i:27;s:2:\"11\";i:28;s:2:\"12\";i:29;s:2:\"13\";i:30;s:2:\"23\";i:31;s:2:\"20\";i:32;s:2:\"24\";i:33;s:2:\"25\";i:34;s:2:\"21\";i:35;s:2:\"26\";i:36;s:2:\"22\";i:37;s:2:\"27\";i:38;s:2:\"28\";i:39;s:2:\"29\";}}', '1', '100', '1', '0', '1541207843', '0');
INSERT INTO `ey_auth_role` VALUES ('2', '内容管理员', '0', '', '0', 'a:1:{i:0;s:2:\"cn\";}', '0', '1', 'a:3:{i:0;s:3:\"add\";i:1;s:4:\"edit\";i:2;s:3:\"del\";}', 'a:2:{s:5:\"rules\";a:4:{i:0;s:1:\"1\";i:1;s:2:\"10\";i:2;s:2:\"14\";i:3;i:2;}s:7:\"arctype\";a:40:{i:0;s:1:\"1\";i:1;s:1:\"2\";i:2;s:1:\"3\";i:3;s:1:\"4\";i:4;s:1:\"5\";i:5;s:1:\"6\";i:6;s:2:\"33\";i:7;s:2:\"34\";i:8;s:2:\"35\";i:9;s:2:\"36\";i:10;s:2:\"37\";i:11;s:2:\"38\";i:12;s:2:\"39\";i:13;s:2:\"40\";i:14;s:2:\"41\";i:15;s:2:\"42\";i:16;s:2:\"43\";i:17;s:2:\"44\";i:18;s:2:\"45\";i:19;s:2:\"46\";i:20;s:2:\"47\";i:21;s:2:\"48\";i:22;s:1:\"8\";i:23;s:2:\"32\";i:24;s:1:\"9\";i:25;s:2:\"30\";i:26;s:2:\"31\";i:27;s:2:\"11\";i:28;s:2:\"12\";i:29;s:2:\"13\";i:30;s:2:\"23\";i:31;s:2:\"20\";i:32;s:2:\"24\";i:33;s:2:\"25\";i:34;s:2:\"21\";i:35;s:2:\"26\";i:36;s:2:\"22\";i:37;s:2:\"27\";i:38;s:2:\"28\";i:39;s:2:\"29\";}}', '1', '100', '1', '0', '1541207846', '0');
